# A common coding interview question

###
elisabethgross
*Updated on *
・2 min read

Weekly Challenges (4 Part Series)

Hey everyone! Welcome back to Code Review, a series of interview challenges released weekly that are completely free for the community. This week we’ll be working on a common, relatively straightforward question that I personally have been asked multiple times in interviews. I chose this challenge because there are multiple ways to approach the problem, each with various time and space trade-offs.

## The Challenge:

Write a function, `FindIntersection`

, that reads an array of strings which will contain two elements: the first element will represent a list of comma-separated numbers sorted in ascending order, the second element will represent a second list of comma-separated numbers (also sorted). Your goal is to return a string of numbers that occur in both elements of the input array in sorted order. If there is no intersection, return the string `"false"`

.

For example: if the input array is `["1, 3, 4, 7, 13", "1, 2, 4, 13, 15"]`

the output string should be `"1, 4, 13"`

because those numbers appear in both strings. The array given will not be empty, and each string inside the array will be of numbers sorted in ascending order and may contain negative numbers.

## The Brute Force Solution:

A brute-force solution is to loop over the numbers of the first string, and for each number in the first string, loop over all numbers of the other string, looking for a match. If a match is found, concat that value to a result string.

```
function FindIntersection (strArr) {
const inBothStrings = []
const arr1 = strArr[0].split(', ')
const arr2 = strArr[1].split(', ')
arr1.forEach(elementArr1 => {
const numArr1 = parseInt(elementArr1)
arr2.forEach(elementArr2 => {
const numArr2 = parseInt(elementArr2)
if (numArr1 === numArr2) {
inBothStrings.push(numArr1)
}
})
})
return inBothStrings.join(',')
}
```

Although this will work, it is not the most optimal solution. The worst case scenario (if there are no matches) is that for every element in the first string, we will have to iterate through every element in the second string. This has a time complexity of `O(nm)`

where `n`

and `m`

are the size of the given strings.

If you haven’t heard of Big O notation, check out this great article which goes into all the details. Understanding Big O notation and being able to communicate how optimal your solution is to an interviewer is an extremely important part of any technical interview.

## Try it Out:

Head on over to Coderbyte and try and solve the problem in a more optimized way. Remember to come back next week where I’ll discuss some other solutions and common pitfalls to this problem. Good luck coding :)

Weekly Challenges (4 Part Series)

I don't usually do JS, but it has became pretty decent in the last few years:

But

`[...s1].filter(x => s2.has(x))`

is still O(n²), isn't it?I'm pretty sure there is a O(s1) + O(s2) = O(n) solution.

Membership tests on

`Set`

s are O(1) not O(n), in other words there is no inner`forEach`

.To clarify: you don't need to iterate over each element in a set for a membership test. They can be implemented as e.g. hash maps. If a key exists, the element is in the set. Hash map lookups are generally O(1).

Yes, I've looked up how

`Set`

works and you're right. Thanks for clarifying.Another cool solution (but not as readable as yours) however is this "destructive" one on SO.

FWIW

`filter`

+`has`

is also how the MDN docs define intersection.developer.mozilla.org/en-US/docs/W...

Good answer but you lost the ordering when using sets.

According to the docs sets will be iterated in insertion order. So the solution will propably work, but rely on an implementation detail to do so, which is not ideal.

Nice solution! Love your use of Sets. Very concise and clear.

because I'd argue that letting your language work for you, and therefore optimizing developer time, is better than optimizing execution time when not strictly necessary.

To follow up: I made three versions of this code. The first version is as above, the second version has the naive approach to finding the intersection:

and a third approach uses a map for lookup:

Performing some timed tests shows that using the built-in function consistently takes about two to three times as long as the self-built map-based function, growing at roughly

`O(n)`

using a random array of size 1000 and 10000. Only in exceptional cases would I not use the built-in function.The naive approach, on the other hand, grows with

`O(n²)`

and takes significantly longer at larger array sizes. However, with 26ms with an array size of 1000, it depends on the use case whether I would start optimizing this (if this isn't easily replaced with a built-in function).Nice work!! Always always interesting to test out a language's built in methods and know whats what when it comes to time complexity.

When the language solves the problem for you... touché

Rust solution - works for any number of strings:

Is there any difference between

and

?

None that I'm aware of. I prefer

`"".to_owned()`

over`String::from("")`

or`"".to_string()`

to avoid the confusion of "why are you converting a string to a string?" that I've seen in some newbie Rust threads.this is my solution, Im no pretty good at JS but I want to be a master on it :)

ok, i have no idea to make my code look like editor

Nice job! And try surrounding your code with triple backticks to format the code ;)

thanks I made it :D i'll wait for more

also you can put javascript directly after your backticks to make it have syntax highlighting (maybe its js, dont know, also works for other languages)

Pro tip!!

Hi! I wrote a solution that should be able to handle n-number of lines.

Also it does not care if there are duplicate numbers or they are out of order.

It just uses .map and .reduce.. probably it still could be optimized by using Set.

simplified the solution by using Sets and corrected the answer to correspond the assignment

couldn't help myself.. improved the performance by sorting sets and checking result set. Changed the api from array input to n-amount of params. Also input is filtered from not a number

Decided to have a one more improvement for performance (when one Set has size = 0, so no need to reduce other Sets. Also result from reduce is directly an array of numbers).

Also my apologies to @elisabethgross as I noticed the tag #codenewbie in the challenge and my answer isn't really for newbies.

Not a JS guy, so I decided to do it in Python.

As an interviewer, for these kind of question I'm not a fan of leveraging too much of the language built-ins (such as sets), as it masks algorithmic thinking, which I believe is an important part of the interview.

My solution uses a dictionary to count the number of occurrences for every item.

I agree about not leveraging too many language built-ins, or, making sure to talk about the time complexity of those built-ins!

This is my approach.

Nice custom parseArray function!! And I like that use of Object.entries().

I used for loop so that improve the performance

fwiw, another js option:

jsfiddle.net/4usxLhyo/1/

sorry, first post, not sure how to get the js syntax highlighting...

Edit: thanks @elisabethgross for the syntax highlighting help!

Nice! If you use the triple backticks, you can write

`javascript`

next to the top triple backticks. Check out this helpful markdown cheat sheet!This is my O(n) solution. We don't need to parse any of the strings to an integer.

A rust solution, im quite new to rust, so this is probably quite ugly

coderbyte.com/results/philipgg:Fin...

I submitted a 0(2n-a) where a is the number of repetitive elements.

The idea is to use that the arrays are sorted so always increment from where we are.

if the elements are matching, save and then increment both counters.

Else increment the count of the array which has the lower number, to try to find the bigger one. (this is auto-switching between the two.)

Nice! Was waiting for someone to come up with this one!

My solution was the same.

When it comes to challenges I prefer algorithms that can be written in pseudocode and don't use many special (or language-specific) data types.

Python solution, not in a nice format, and assuming the input are two integer arrays:

So idea:

You iterate over the smallest array, at each step, you are in one of 3 situations

arr1[i] == arra2[j] // you increment i and j because of the invariant, that says the arrays are sorted, so if you found a match you can safely increment.

arr1[i] < arr2[j] // since at index i we have the smallest element, we increment that one because being sorter we ca safely increment until we hit what is at index j or greater

arr1[i] < arr2[j] // same as above only for j

Would be the easiest to implement (I'm on my phone so I can't check it, also, python)

// I believe key here is that both arrays are sorted

function FindIntersection (strArr) {

const inBothStrings = []

const arr1 = strArr[0].split(', ')

const arr2 = strArr[1].split(', ')

let i=0,j=0;

while (i<arr1.length&&j<arr2.length){

//casting to numbers

let a = arr1[i]|0;

let b = arr2[j]|0;

if(a==b){

inBothStrings.push(a)

i++;

j++;

}

else if(a>b){

j++;

}

else if(b>a){

i++;

}

}

return inBothStrings.join(',')

}

Bingo! Nice work!

Thank you!

I dont understand why anyone would ask you this in an interview ? A massive red flag for me.

Clarification question: can the lists have duplicate values?

Good question! Nope, the lists will not have duplicates in themselves.

Kotlin (any number of strings): pl.kotl.in/Lgfcz5KnV?theme=darcula